searchNodes=[{"doc":"use CharonOauth2 , @charon_config","ref":"CharonOauth2.html","title":"CharonOauth2","type":"module"},{"doc":"Default token verification call used in refresh_token grant. Can be overridden using config opt :verify_refresh_token , in which case there is no need to call Charon.TokenPlugs.verify_no_auth_error/2 . Checks: signature valid already valid (&quot;nbf&quot; claim) not expired (&quot;exp&quot; claim) token type is &quot;refresh&quot; (&quot;type&quot; claim) session type is &quot;oauth2&quot; (&quot;styp&quot; claim) session exists token is fresh (grace period 10 seconds)","ref":"CharonOauth2.html#verify_refresh_token/2","title":"CharonOauth2.verify_refresh_token/2","type":"function"},{"doc":"Config module for CharonOauth2 . Charon.Config . from_enum ( ... , optional_modules : %{ CharonOauth2 =&gt; %{ repo : MyApp.Repo , resource_owner_schema : MyApp.User , scopes : ~w(profile:read door:open) , # following are defaults authorizations_table : &quot;charon_oauth2_authorizations&quot; , clients_table : &quot;charon_oauth2_clients&quot; , customize_session_upsert_args : &amp; Function . identity / 1 , enforce_pkce : :all , grants_table : &quot;charon_oauth2_grants&quot; , grant_ttl : 10 * 60 , resource_owner_id_column : :id , resource_owner_id_type : :bigserial , verify_refresh_token : &amp; CharonOauth2 . verify_refresh_token / 2 } } ) Supported config options :repo (required) the Ecto repo module of your application. :resource_owner_schema (required) the user schema module of your application. :scopes (required) the scopes that are available to Oauth2 apps, application-wide. :authorizations_table the name of the table in which to store authorizations. :clients_table the name of the table in which to store clients. :customize_session_upsert_args a function that you can use to customize the arguments that are passed by your MyApp.TokenEndpoint to Charon.SessionPlugs.upsert_session/3 . Be careful, usually you might want to add to these arguments, but not override them. :enforce_pkce for :public , :all or :no clients :grant_ttl time in seconds that a grant (mostly authorization code) takes to expire :grants_table the name of the table in which to store grants :resource_owner_id_column the column name, as an atom, of the resource owner's schema's primary key :resource_owner_id_type the type, as an atom, of the resource owner's schema's primary key :verify_refresh_token a function that you can use to verify an Oauth2 refresh token for the refresh token grant.","ref":"CharonOauth2.Config.html","title":"CharonOauth2.Config","type":"module"},{"doc":"Build config struct from enumerable (useful for passing in application environment). Raises for missing mandatory keys and sets defaults for optional keys.","ref":"CharonOauth2.Config.html#from_enum/1","title":"CharonOauth2.Config.from_enum/1","type":"function"},{"doc":"","ref":"CharonOauth2.Config.html#t:t/0","title":"CharonOauth2.Config.t/0","type":"type"},{"doc":"Helper module for client app migrations. Usage defmodule MyApp.Repo.Migrations.Oauth2Models do use Ecto.Migration def change , do : CharonOauth2.Migration . change ( charon_config ) end","ref":"CharonOauth2.Migration.html","title":"CharonOauth2.Migration","type":"module"},{"doc":"Call from a migration to generate CharonOauth2 models. Supports rollbacks as well.","ref":"CharonOauth2.Migration.html#change/1","title":"CharonOauth2.Migration.change/1","type":"function"},{"doc":"Ecto type for encrypted data. Takes any binary as input. Requires a column of type :binary .","ref":"CharonOauth2.Types.Encrypted.html","title":"CharonOauth2.Types.Encrypted","type":"module"},{"doc":"Ecto type to only store an HMAC of the input data. This means the original data cannot be retrieved, but a record can be found by an exact equality match. Requires a column of type :binary .","ref":"CharonOauth2.Types.Hmac.html","title":"CharonOauth2.Types.Hmac","type":"module"},{"doc":"Ecto type for casting a string with a pattern-separated list of values to an ordered-set string array. All pattern types of String.split/3 are supported. Empty strings are trimmed from the result by default. Example schema &quot;separated_things&quot; do field :comma_separated , SeparatedStringOrdset , pattern : &quot;,&quot; field :comma_or_semicolon_separated , SeparatedStringOrdset , pattern : ~w(, ;) field :regex_separated , SeparatedStringOrdset , pattern : ~r/,/ field :comma_separated_with_empty_strings , SeparatedStringOrdset , pattern : &quot;,&quot; , split_opts : [ ] end Doctests @opts SeparatedStringOrdset . init ( pattern : &quot;,&quot; ) iex&gt; { :ok , ~w(bar baz foo) } = SeparatedStringOrdset . cast ( &quot;foo,bar,baz,bar&quot; , @opts ) iex&gt; :error = SeparatedStringOrdset . cast ( [ 1 , 2 , &quot;3&quot; ] , @opts ) iex&gt; { :ok , ~w(1 2 true) } = SeparatedStringOrdset . cast ( &quot;1,2,true&quot; , @opts ) iex&gt; { :ok , ~w(a b c) } = SeparatedStringOrdset . cast ( ~w(a b c) , @opts ) iex&gt; opts = SeparatedStringOrdset . init ( pattern : &quot;,&quot; , split_opts : [ ] ) iex&gt; { :ok , [ &quot;&quot; , &quot;bar&quot; , &quot;foo&quot; ] } = SeparatedStringOrdset . cast ( &quot;foo,bar,&quot; , opts )","ref":"CharonOauth2.Types.SeparatedStringOrdset.html","title":"CharonOauth2.Types.SeparatedStringOrdset","type":"module"},{"doc":"Encrypt/decrypt data using ChaCha20.","ref":"CharonOauth2.Utils.Crypto.html","title":"CharonOauth2.Utils.Crypto","type":"module"},{"doc":"Decrypt a binary using the provided key and return the plaintext or an error.","ref":"CharonOauth2.Utils.Crypto.html#decrypt/2","title":"CharonOauth2.Utils.Crypto.decrypt/2","type":"function"},{"doc":"Encrypt the plaintext into a binary using the provided key.","ref":"CharonOauth2.Utils.Crypto.html#encrypt/2","title":"CharonOauth2.Utils.Crypto.encrypt/2","type":"function"},{"doc":"A dummy app used to test CharonOauth2 and to present documentation for the generated modules.","ref":"MyApp.html","title":"MyApp","type":"module"},{"doc":"Entrypoint module for CharonOauth2. The following submodules are generated: Elixir.MyApp.CharonOauth2.Authorization Elixir.MyApp.CharonOauth2.Authorizations Elixir.MyApp.CharonOauth2.Client Elixir.MyApp.CharonOauth2.Clients Elixir.MyApp.CharonOauth2.Grant Elixir.MyApp.CharonOauth2.Grants Elixir.MyApp.CharonOauth2.Plugs.AuthorizationEndpoint Elixir.MyApp.CharonOauth2.Plugs.TokenEndpoint","ref":"MyApp.CharonOauth2.html","title":"MyApp.CharonOauth2","type":"module"},{"doc":"An authorization represents the permission granted by a resource owner (usually a user) to an application to act on their behalf within certain limits (determined by scopes). Field :scope is guaranteed to be an ordset ( :ordsets ).","ref":"MyApp.CharonOauth2.Authorization.html","title":"MyApp.CharonOauth2.Authorization","type":"module"},{"doc":"Basic changeset.","ref":"MyApp.CharonOauth2.Authorization.html#changeset/2","title":"MyApp.CharonOauth2.Authorization.changeset/2","type":"function"},{"doc":"Insert-only changeset - some things (should) never change.","ref":"MyApp.CharonOauth2.Authorization.html#insert_only_changeset/2","title":"MyApp.CharonOauth2.Authorization.insert_only_changeset/2","type":"function"},{"doc":"Returns a new query with the current module as named binding :charon_oauth2_authorization .","ref":"MyApp.CharonOauth2.Authorization.html#named_binding/0","title":"MyApp.CharonOauth2.Authorization.named_binding/0","type":"function"},{"doc":"Preload named bindings. Automatically joins using resolve_binding/2 .","ref":"MyApp.CharonOauth2.Authorization.html#preload/2","title":"MyApp.CharonOauth2.Authorization.preload/2","type":"function"},{"doc":"Resolve named bindings that are not present in the query by (left-)joining to the appropriate tables.","ref":"MyApp.CharonOauth2.Authorization.html#resolve_binding/2","title":"MyApp.CharonOauth2.Authorization.resolve_binding/2","type":"function"},{"doc":"Bindings / preloads that can be used with resolve_binding/2 and preload/2","ref":"MyApp.CharonOauth2.Authorization.html#t:resolvable/0","title":"MyApp.CharonOauth2.Authorization.resolvable/0","type":"type"},{"doc":"","ref":"MyApp.CharonOauth2.Authorization.html#t:t/0","title":"MyApp.CharonOauth2.Authorization.t/0","type":"type"},{"doc":"Context to manage authorizations","ref":"MyApp.CharonOauth2.Authorizations.html","title":"MyApp.CharonOauth2.Authorizations","type":"module"},{"doc":"Get a list of all oauth2 authorizations. Doctests iex&gt; insert_test_authorization ( ) iex&gt; [ % Authorization { } ] = Authorizations . all ( ) # can be filtered iex&gt; authorization = insert_test_authorization ( ) iex&gt; [ % Authorization { } ] = Authorizations . all ( %{ resource_owner_id : authorization . resource_owner_id } ) iex&gt; [ % Authorization { } ] = Authorizations . all ( %{ scope : authorization . scope |&gt; List . first ( ) } ) iex&gt; [ ] = Authorizations . all ( %{ resource_owner_id : authorization . resource_owner_id + 1 } )","ref":"MyApp.CharonOauth2.Authorizations.html#all/2","title":"MyApp.CharonOauth2.Authorizations.all/2","type":"function"},{"doc":"Delete an authorization. Examples / doctests # authorization must exist iex&gt; { :error , :not_found } = Authorizations . delete ( id : - 1 ) # succesfully deletes an authorization iex&gt; authorization = insert_test_authorization ( ) iex&gt; { :ok , _ } = Authorizations . delete ( [ id : authorization . id ] ) iex&gt; { :error , :not_found } = Authorizations . delete ( [ id : authorization . id ] )","ref":"MyApp.CharonOauth2.Authorizations.html#delete/1","title":"MyApp.CharonOauth2.Authorizations.delete/1","type":"function"},{"doc":"Get a single authorization by one or more clauses, optionally with preloads. Returns nil if Authorization cannot be found. Doctests iex&gt; authorization = insert_test_authorization ( ) iex&gt; % Authorization { } = Authorizations . get_by ( id : authorization . id ) iex&gt; nil = Authorizations . get_by ( id : authorization . id + 1 ) # preloads things iex&gt; authorization = insert_test_authorization ( ) iex&gt; %{ resource_owner : %{ id : _ } , client : %{ id : _ } } = Authorizations . get_by ( [ id : authorization . id ] , Authorization . supported_preloads )","ref":"MyApp.CharonOauth2.Authorizations.html#get_by/2","title":"MyApp.CharonOauth2.Authorizations.get_by/2","type":"function"},{"doc":"Insert a new authorization Examples / doctests # succesfully creates an authorization iex&gt; { :ok , _ } = authorization_params ( ) |&gt; Authorizations . insert ( ) # a user can authorize a client only once iex&gt; { :ok , authorization } = authorization_params ( ) |&gt; Authorizations . insert ( ) iex&gt; authorization_params ( client_id : authorization . client_id , resource_owner_id : authorization . resource_owner_id ) |&gt; Authorizations . insert ( ) |&gt; errors_on ( ) %{ client_id : [ &quot;user already authorized this client&quot; ] } # owner and client must exist iex&gt; authorization_params ( resource_owner_id : - 1 ) |&gt; Authorizations . insert ( ) |&gt; errors_on ( ) %{ resource_owner : [ &quot;does not exist&quot; ] } iex&gt; authorization_params ( client_id : Ecto.UUID . generate ( ) ) |&gt; Authorizations . insert ( ) |&gt; errors_on ( ) %{ client : [ &quot;does not exist&quot; ] } iex&gt; Authorizations . insert ( %{ } ) |&gt; errors_on ( ) %{ scope : [ &quot;can&#39;t be blank&quot; ] , client_id : [ &quot;can&#39;t be blank&quot; ] , resource_owner_id : [ &quot;can&#39;t be blank&quot; ] }","ref":"MyApp.CharonOauth2.Authorizations.html#insert/1","title":"MyApp.CharonOauth2.Authorizations.insert/1","type":"function"},{"doc":"Update an authorization. Examples / doctests # scopes must be subset of configured scopes and of client scopes iex&gt; insert_test_authorization ( ) |&gt; Authorizations . update ( %{ scope : ~w(cry) } ) |&gt; errors_on ( ) %{ scope : [ &quot;must be subset of party, read, write&quot; ] } iex&gt; insert_test_authorization ( ) |&gt; Authorizations . update ( %{ scope : ~w(write write) } ) |&gt; errors_on ( ) %{ scope : [ &quot;client not allowed to access scope(s): write&quot; ] } # client and resource owner can&#39;t be updated iex&gt; %{ id : id , client_id : client_id , resource_owner_id : owner_id } = insert_test_authorization ( ) iex&gt; { :ok , %{ client_id : ^ client_id , resource_owner_id : ^ owner_id } } = Authorizations . update ( [ id : id ] , %{ client_id : - 1 , owner_id : - 1 } )","ref":"MyApp.CharonOauth2.Authorizations.html#update/2","title":"MyApp.CharonOauth2.Authorizations.update/2","type":"function"},{"doc":"An Oauth2 (third-party) client application. Fields :scope , :grant_types and :redirect_uris are guaranteed to be ordsets ( :ordsets ). The client secret is stored encrypted, not hashed, which is unusual for passwords-like secrets. In line with, for example, GCP, we choose to be able to show the client secret again. Also, the client secret is not a normal password but a 384 bits random string, which does not require key stretching to prevent brute forcing (although rate-limiting the token endpoint may still be desirable).","ref":"MyApp.CharonOauth2.Client.html","title":"MyApp.CharonOauth2.Client","type":"module"},{"doc":"Basic changeset.","ref":"MyApp.CharonOauth2.Client.html#changeset/2","title":"MyApp.CharonOauth2.Client.changeset/2","type":"function"},{"doc":"Insert-only changeset.","ref":"MyApp.CharonOauth2.Client.html#insert_only_changeset/2","title":"MyApp.CharonOauth2.Client.insert_only_changeset/2","type":"function"},{"doc":"Returns a new query with the current module as named binding :charon_oauth2_client .","ref":"MyApp.CharonOauth2.Client.html#named_binding/0","title":"MyApp.CharonOauth2.Client.named_binding/0","type":"function"},{"doc":"Preload named bindings. Automatically joins using resolve_binding/2 .","ref":"MyApp.CharonOauth2.Client.html#preload/2","title":"MyApp.CharonOauth2.Client.preload/2","type":"function"},{"doc":"Resolve named bindings that are not present in the query by (left-)joining to the appropriate tables.","ref":"MyApp.CharonOauth2.Client.html#resolve_binding/2","title":"MyApp.CharonOauth2.Client.resolve_binding/2","type":"function"},{"doc":"Bindings / preloads that can be used with resolve_binding/2 and preload/2","ref":"MyApp.CharonOauth2.Client.html#t:resolvable/0","title":"MyApp.CharonOauth2.Client.resolvable/0","type":"type"},{"doc":"","ref":"MyApp.CharonOauth2.Client.html#t:t/0","title":"MyApp.CharonOauth2.Client.t/0","type":"type"},{"doc":"Context to manage clients","ref":"MyApp.CharonOauth2.Clients.html","title":"MyApp.CharonOauth2.Clients","type":"module"},{"doc":"Get a list of all oauth2 clients. Doctests iex&gt; client = insert_test_client ( ) iex&gt; [ ^ client ] = Clients . all ( ) # can be filtered iex&gt; client = insert_test_client ( ) iex&gt; [ ^ client ] = Clients . all ( %{ owner_id : client . owner_id } ) iex&gt; [ ^ client ] = Clients . all ( %{ grant_types : &quot;authorization_code&quot; } ) iex&gt; [ ] = Clients . all ( %{ owner_id : client . owner_id + 1 } )","ref":"MyApp.CharonOauth2.Clients.html#all/2","title":"MyApp.CharonOauth2.Clients.all/2","type":"function"},{"doc":"Delete a client. Examples / doctests # client must exist iex&gt; { :error , :not_found } = Clients . delete ( id : Ecto.UUID . generate ( ) ) # succesfully deletes a client iex&gt; client = insert_test_client ( ) iex&gt; { :ok , _ } = Clients . delete ( [ id : client . id ] ) iex&gt; { :error , :not_found } = Clients . delete ( [ id : client . id ] )","ref":"MyApp.CharonOauth2.Clients.html#delete/1","title":"MyApp.CharonOauth2.Clients.delete/1","type":"function"},{"doc":"Get a single client by one or more clauses, optionally with preloads. Returns nil if Client cannot be found. Doctests iex&gt; client = insert_test_client ( ) iex&gt; % Client { } = Clients . get_by ( id : client . id ) iex&gt; nil = Clients . get_by ( id : Ecto.UUID . generate ( ) ) # preloads things iex&gt; client = insert_test_client ( ) iex&gt; auth = insert_test_authorization ( client_id : client . id ) iex&gt; insert_test_grant ( authorization_id : auth . id ) iex&gt; %{ owner : %{ id : _ } , authorizations : [ _ ] } = Clients . get_by ( [ id : client . id ] , Client . supported_preloads )","ref":"MyApp.CharonOauth2.Clients.html#get_by/2","title":"MyApp.CharonOauth2.Clients.get_by/2","type":"function"},{"doc":"Insert a new client. Examples / doctests # succesfully creates a client with a secret iex&gt; user = insert_test_user ( ) iex&gt; { :ok , client } = client_params ( owner_id : user . id ) |&gt; Clients . insert ( ) iex&gt; %{ secret : &lt;&lt; _ :: binary &gt;&gt; } = client # owner must exist iex&gt; client_params ( owner_id : - 1 ) |&gt; Clients . insert ( ) |&gt; errors_on ( ) %{ owner : [ &quot;does not exist&quot; ] } iex&gt; Clients . insert ( %{ } ) |&gt; errors_on ( ) %{ grant_types : [ &quot;can&#39;t be blank&quot; ] , name : [ &quot;can&#39;t be blank&quot; ] , owner_id : [ &quot;can&#39;t be blank&quot; ] , redirect_uris : [ &quot;can&#39;t be blank&quot; ] , scope : [ &quot;can&#39;t be blank&quot; ] }","ref":"MyApp.CharonOauth2.Clients.html#insert/1","title":"MyApp.CharonOauth2.Clients.insert/1","type":"function"},{"doc":"Update a client. Examples / doctests iex&gt; client = insert_test_client ( ) iex&gt; { :ok , updated } = Clients . update ( client , %{ secret : &quot;new!&quot; } ) iex&gt; false = updated . secret == client . secret # secret is randomly generated on update iex&gt; client = insert_test_client ( ) iex&gt; { :ok , updated } = Clients . update ( [ id : client . id ] , %{ secret : &quot;new!&quot; } ) iex&gt; false = updated . secret == client . secret iex&gt; false = updated . secret == &quot;new!&quot; # scopes must be subset of configured scopes iex&gt; client = insert_test_client ( ) iex&gt; Clients . update ( [ id : client . id ] , %{ scope : ~w(cry) } ) |&gt; errors_on ( ) %{ scope : [ &quot;must be subset of party, read, write&quot; ] } # underlying authrorization scopes are reduced to client&#39;s reduced scopes iex&gt; client = insert_test_client ( scope : ~w(read write) ) iex&gt; authorization = insert_test_authorization ( client_id : client . id , scope : ~w(read write) ) iex&gt; { :ok , _ } = Clients . update ( [ id : client . id ] , %{ scope : ~w(read) } ) iex&gt; %{ scope : ~w(read) } = Authorizations . get_by ( id : authorization . id ) # id and owner id can&#39;t be updated iex&gt; %{ id : id , owner_id : owner_id } = insert_test_client ( ) iex&gt; { :ok , %{ id : ^ id , owner_id : ^ owner_id } } = Clients . update ( [ id : id ] , %{ id : Ecto.UUID . generate ( ) , owner_id : - 1 } )","ref":"MyApp.CharonOauth2.Clients.html#update/2","title":"MyApp.CharonOauth2.Clients.update/2","type":"function"},{"doc":"","ref":"MyApp.CharonOauth2.Config.html","title":"MyApp.CharonOauth2.Config","type":"module"},{"doc":"","ref":"MyApp.CharonOauth2.Config.html#get/0","title":"MyApp.CharonOauth2.Config.get/0","type":"function"},{"doc":"","ref":"MyApp.CharonOauth2.Config.html#get_auth_uri/0","title":"MyApp.CharonOauth2.Config.get_auth_uri/0","type":"function"},{"doc":"","ref":"MyApp.CharonOauth2.Config.html#get_secret/0","title":"MyApp.CharonOauth2.Config.get_secret/0","type":"function"},{"doc":"A grant is an (in-progress) Oauth2 flow to obtain auth tokens. Not every flow needs server-side state to be stored, for example, the implicit grant immediately returns an access token in response to the authorization request, and does not have a second exchange-code-for-token request-response cycle.","ref":"MyApp.CharonOauth2.Grant.html","title":"MyApp.CharonOauth2.Grant","type":"module"},{"doc":"Insert-only changeset - some things (should) never change.","ref":"MyApp.CharonOauth2.Grant.html#insert_only_changeset/2","title":"MyApp.CharonOauth2.Grant.insert_only_changeset/2","type":"function"},{"doc":"Sets the current module name as a camelcase named binding in an Ecto query","ref":"MyApp.CharonOauth2.Grant.html#named_binding/0","title":"MyApp.CharonOauth2.Grant.named_binding/0","type":"function"},{"doc":"Preload named bindings. Automatically joins using resolve_binding/2 .","ref":"MyApp.CharonOauth2.Grant.html#preload/2","title":"MyApp.CharonOauth2.Grant.preload/2","type":"function"},{"doc":"Resolve named bindings that are not present in the query by (left-)joining to the appropriate tables.","ref":"MyApp.CharonOauth2.Grant.html#resolve_binding/2","title":"MyApp.CharonOauth2.Grant.resolve_binding/2","type":"function"},{"doc":"Bindings / preloads that can be used with resolve_binding/2 and preload/2","ref":"MyApp.CharonOauth2.Grant.html#t:resolvable/0","title":"MyApp.CharonOauth2.Grant.resolvable/0","type":"type"},{"doc":"","ref":"MyApp.CharonOauth2.Grant.html#t:t/0","title":"MyApp.CharonOauth2.Grant.t/0","type":"type"},{"doc":"Context to manage grants","ref":"MyApp.CharonOauth2.Grants.html","title":"MyApp.CharonOauth2.Grants","type":"module"},{"doc":"Get a list of all oauth2 grants. Doctests iex&gt; insert_test_grant ( ) iex&gt; [ % Grant { } ] = Grants . all ( ) # can be filtered iex&gt; grant = insert_test_grant ( ) iex&gt; [ % Grant { } ] = Grants . all ( %{ authorization_id : grant . authorization_id } ) iex&gt; [ % Grant { } ] = Grants . all ( %{ code : grant . code } ) iex&gt; [ ] = Grants . all ( %{ authorization_id : grant . authorization_id + 1 } )","ref":"MyApp.CharonOauth2.Grants.html#all/2","title":"MyApp.CharonOauth2.Grants.all/2","type":"function"},{"doc":"Delete a grant. Examples / doctests # grant must exist iex&gt; { :error , :not_found } = Grants . delete ( id : - 1 ) # succesfully deletes a grant iex&gt; grant = insert_test_grant ( ) iex&gt; { :ok , _ } = Grants . delete ( [ id : grant . id ] ) iex&gt; { :error , :not_found } = Grants . delete ( [ id : grant . id ] )","ref":"MyApp.CharonOauth2.Grants.html#delete/1","title":"MyApp.CharonOauth2.Grants.delete/1","type":"function"},{"doc":"Delete all grants older than the configured grant_ttl . Examples / doctests iex&gt; valid = insert_test_grant ( ) iex&gt; expired = insert_test_grant ( ) iex&gt; past = DateTime . utc_now ( ) |&gt; DateTime . add ( - 10 ) iex&gt; from ( t in Grant , where : t . id == ^ expired . id ) |&gt; Repo . update_all ( set : [ expires_at : past ] ) iex&gt; Grants . delete_expired ( ) iex&gt; valid_id = valid . id iex&gt; [ %{ id : ^ valid_id } ] = Grants . all ( )","ref":"MyApp.CharonOauth2.Grants.html#delete_expired/0","title":"MyApp.CharonOauth2.Grants.delete_expired/0","type":"function"},{"doc":"Get a single grant by one or more clauses, optionally with preloads. Returns nil if Grant cannot be found. Doctests iex&gt; grant = insert_test_grant ( ) iex&gt; % Grant { } = Grants . get_by ( id : grant . id ) iex&gt; nil = Grants . get_by ( id : grant . id + 1 ) # preloads things iex&gt; grant = insert_test_grant ( ) iex&gt; %{ authorization : %{ client : %{ id : _ } } } = Grants . get_by ( [ id : grant . id ] , Grant . supported_preloads ) # a grant can be retrieved by its code (actually by the HMAC of its code) iex&gt; %{ id : id , code : code } = insert_test_grant ( ) iex&gt; ^ id = Grants . get_by ( code : code ) . id","ref":"MyApp.CharonOauth2.Grants.html#get_by/2","title":"MyApp.CharonOauth2.Grants.get_by/2","type":"function"},{"doc":"Insert a new grant Examples / doctests # succesfully creates a grant iex&gt; { :ok , _ } = grant_params ( ) |&gt; Grants . insert ( ) iex&gt; Grants . insert ( %{ } ) |&gt; errors_on ( ) %{ authorization_id : [ &quot;can&#39;t be blank&quot; ] , type : [ &quot;can&#39;t be blank&quot; ] , resource_owner_id : [ &quot;can&#39;t be blank&quot; ] } # authorization must exist iex&gt; grant_params ( authorization_id : - 1 ) |&gt; Grants . insert ( ) |&gt; errors_on ( ) %{ authorization : [ &quot;does not exist&quot; ] } # resource owner must exist and must match the authorization&#39;s owner iex&gt; grant_params ( resource_owner_id : - 1 ) |&gt; Grants . insert ( ) |&gt; errors_on ( ) %{ authorization_id : [ &quot;belongs to other resource owner&quot; ] } # type must be one of client grant_type&#39;s iex&gt; client = insert_test_client ( grant_types : ~w(refresh_token) ) iex&gt; authorization = insert_test_authorization ( client_id : client . id ) iex&gt; grant_params ( authorization_id : authorization . id ) |&gt; Grants . insert ( ) |&gt; errors_on ( ) %{ type : [ &quot;not supported by client&quot; ] } # redirect_uri must be one of client redirect_uri&#39;s iex&gt; grant_params ( redirect_uri : &quot;https://boom&quot; ) |&gt; Grants . insert ( ) |&gt; errors_on ( ) %{ redirect_uri : [ &quot;does not match client&quot; ] } # redirect_uri is required if client has multiple uris set iex&gt; client = insert_test_client ( redirect_uris : ~w(https://a https://b) ) iex&gt; authorization = insert_test_authorization ( client_id : client . id ) iex&gt; grant_params ( authorization_id : authorization . id , redirect_uri : nil ) |&gt; Grants . insert ( ) |&gt; errors_on ( ) %{ redirect_uri : [ &quot;can&#39;t be blank&quot; ] } iex&gt; grant_params ( authorization_id : authorization . id , redirect_uri : &quot;https://c&quot; ) |&gt; Grants . insert ( ) |&gt; errors_on ( ) %{ redirect_uri : [ &quot;does not match client&quot; ] }","ref":"MyApp.CharonOauth2.Grants.html#insert/1","title":"MyApp.CharonOauth2.Grants.insert/1","type":"function"},{"doc":"The Oauth2 authorization endpoint . This endpoint is meant to be combined with a first-party web client in which a user can grant or deny access. So it does not, by itself, behave as an oauth2 authorization endpoint (for example, it only supports POST requests). The endpoint returns a JSON response with 200 OK and a redirect_to parameter, that the web client should then, you know, redirect to. The redirect may also contain an error result. However, there are some errors that must not result in redirection, for example errors in validating the redirect URI itself. Such errors result in a 400 response with an error description, that the companion web client may show to the user at its discretion. User must be logged-in using Charon (at least Charon.TokenPlugs.verify_token_signature/2 must be called on the conn.) Behaviour The endpoint essentially upserts a user's authorization for a client (if the request is valid, of course). A subtlety to note is that the endpoint does not ever reduce the authorized scopes, it only expands them. The reason for this is that an Oauth2 client may request multiple access tokens, some of which have a smaller scope than others. If we reduced the scopes to the request scope, the user would need to re-grant permission every time. In other words, this endpoint is not intended to manage a user's authorizations. It is probably a good idea for a user to be able to fully revoke or reduce the scope of an authorization. For such purposes, applications can simply add authorization CRUD functionality to their API, using MyApp.CharonOauth2.Authorizations functions. Usage alias Elixir.MyApp.CharonOauth2.Plugs.AuthorizationEndpoint # this endpoint MUST only be useable by the first-party authorizing client!!! forward &quot;/oauth2/authorize&quot; , AuthorizationEndpoint , config : @config","ref":"MyApp.CharonOauth2.Plugs.AuthorizationEndpoint.html","title":"MyApp.CharonOauth2.Plugs.AuthorizationEndpoint","type":"module"},{"doc":"The Oauth2 token endpoint . There is no need to pass the conn through Plug.Parsers , because it does so by itself. The endpoint only accepts content type application/x-www-form-urlencoded with utf-8 params. The exceptions raised by Plug.Parsers simply bubble up, your application must return appropriate responses for them (Phoenix applications should do so by default). Usage alias Elixir.MyApp.CharonOauth2.Plugs.TokenEndpoint # this endpoint must be public, without any additional authentication requirements forward &quot;/oauth2/token&quot; , TokenEndpoint , config : @config Client authentication Confidential clients must authenticate using their client secret (and public clients may do so too although there would be little point in it if they can't keep their secret, you know, secret). HTTP Basic authentication takes precedence over req body credentials. Although the spec says clients must not use more than one auth method, it doesn't say auth servers should reject such requests, so we simply decided that HTTP Basic takes priority, because the same spec says that HTTP Basic, at least, must be supported for clients that identify using a client password. IF HTTP Basic auth is used, an authentication failure results in a 401 response with header &quot;www-authenticate&quot; set to &quot;Basic&quot;, instead of a &quot;normal&quot; 400-with-JSON error response. Authorization code with Proof Key for Code Exchange (PKCE) enforced The Oauth 2.1 draft spec recommends enforcing PKCE for the authorization_code grant under all circumstances. That is what we do. Sessions Tokens handed out by this endpoint are backed by a server-side session (that is only loaded on refresh, by default). The session type is :oauth2 , separating these sessions from other sessions that the user may have in Charon . The purpose of this separation is to be able to call delete-all and not drop oauth2-client connections, or the other way around.","ref":"MyApp.CharonOauth2.Plugs.TokenEndpoint.html","title":"MyApp.CharonOauth2.Plugs.TokenEndpoint","type":"module"},{"doc":"CharonOauth2 is a child package of Charon that adds Oauth2 authorization server capability to a Charon-powered application. If you simply add CharonOauth2 to an existing application, you will probably end up with an API that is both the Oauth2 authorization server and resource server. That is perfectly fine, just be careful designing your scopes. Charon is an auth framework for Elixir aimed at APIs. As such, CharonOauth2 does not include an &quot;authorize app X to use your Y account&quot; page. Such a page is necessary for Oauth2, and adding it is left to the client application using whatever stack it chooses. CharonOauth does include an endpoint plug that does almost all of the heavy lifting of such a page, so that CharonOauth2 can be easily used without having to dive into the Oauth2 spec. This makes CharonOauth2 a little less of a batteries-included solution, but since you probably have a web app already, or a stack preference, or obnoxious developers or whatever, this shouldn't be too much of an issue in practice. CharonOauth2 implements recommendations from the Oauth 2.1 draft spec , such as enforcing PKCE with the authorization code grant for all clients.","ref":"readme.html","title":"CharonOauth2","type":"extras"},{"doc":"Charon Table of contents Features Documentation How to use Installation Set up Charon Configuration Migrations Create your CharonOauth2 module Add Oauth2 routes Add an authorization page Add API endpoints needed for authorization page Restrict third-party application access using scopes What are scopes? Enforcing scopes Managing authorizations and clients","ref":"readme.html#table-of-contents","title":"CharonOauth2 - Table of contents","type":"extras"},{"doc":"Oauth 2.1 authorization server implementation supporting authorization_code and refresh_token grants. Out-of-the-box database migrations, models, and contexts. Simple configuration with sane defaults. Revokable refresh tokens thanks to Charon's session store. Symmetric or asymmetric token signatures thanks to Charon's token factory. Safe storage of sensitive data using encryption ( CharonOauth2.Types.Encrypted ) or HMAC ( CharonOauth2.Types.Hmac ) when appropriate. Small number of dependencies.","ref":"readme.html#features","title":"CharonOauth2 - Features","type":"extras"},{"doc":"Documentation can be found at https://hexdocs.pm/charon_oauth2 .","ref":"readme.html#documentation","title":"CharonOauth2 - Documentation","type":"extras"},{"doc":"Installation The package can be installed by adding charon_oauth2 to your list of dependencies in mix.exs : def deps do [ { :charon , &quot;~&gt; 2.0&quot; } , { :charon_oauth2 , &quot;~&gt; 0.0.1-beta3&quot; } ] end Set up Charon Set up Charon first using its readme. Configuration Configuration is easy. You simply add the CharonOauth2 configuration as optional module configuration for Charon. Add your repo, resource owner (user) schema, and scopes. We will discuss scopes in more detail later . For now, you can add an empty list. Charon.Config . from_enum ( ... , optional_modules : %{ CharonOauth2 =&gt; %{ repo : MyApp.Repo , resource_owner_schema : MyApp.User , scopes : [ ] } } ) For all config options, take a look at CharonOauth2.Config . Migrations To create the required database tables, you can use the included migration helper CharonOauth2.Migration . mix ecto.gen.migration charon_oauth2_models defmodule MyApp.Repo.Migrations.CharonOauth2Models do use Ecto.Migration @my_charon_config MyApp.Charon . get_config ( ) def change , do : CharonOauth2.Migration . change ( @my_charon_config ) end Create your CharonOauth2 module To provide you with models, contexts and plugs, CharonOauth2 generates several modules for you. Create a CharonOauth2 module, simply passing in the Charon config: defmodule MyApp.CharonOauth2 do use CharonOauth2 , MyApp.Charon . get_config ( ) end Now you will have the following additional modules: MyApp.CharonOauth2.Authorization MyApp.CharonOauth2.Authorizations MyApp.CharonOauth2.Client MyApp.CharonOauth2.Clients MyApp.CharonOauth2.Grant MyApp.CharonOauth2.Grants MyApp.CharonOauth2.Plugs.AuthorizationEndpoint MyApp.CharonOauth2.Plugs.TokenEndpoint Now you only have to update your user schema: defmodule MyApp.User do use Ecto.Schema alias MyApp.CharonOauth2 . { Authorization , Client } schema &quot;users&quot; do ... has_many :oauth2_authorizations , Authorization , foreign_key : :resource_owner_id has_many :oauth2_clients , Client , foreign_key : :owner_id end end Add Oauth2 routes Oauth2 requires to important endpoints, the authorization endpoint and the token endpoint. You can add both by forwarding to the two &quot;endpoint plugs&quot;: defmodule MyAppWeb.Router do use MyAppWeb , :router alias MyApp.CharonOauth2.Plugs . { AuthorizationEndpoint , TokenEndpoint } import Charon.TokenPlugs @my_charon_config MyApp.Charon . get_config ( ) ... scope &quot;/api&quot; do pipe_through [ :api , :valid_access_token ] # auth endpoint MUST only be accessible by Charon-authenticated users forward &quot;/oauth2/authorize&quot; , AuthorizationEndpoint , config : @my_charon_config end scope &quot;/api&quot; do # token endpoint does its own parsing and requires no authentication forward &quot;/oauth2/token&quot; , TokenEndpoint , config : @my_charon_config end end Add an authorization page The authorization page receives the authorization request from third-party apps (oauth2 clients). Its purpose is to allow the user to grant or deny permission to access or use (parts of) the user's account. This access is limited by scopes. MyApp.CharonOauth2.AuthorizationEndpoint verifies everything that needs verifying, so your implementation does not necessarily have to concern itself with validating query params. However, to provide a nice UX, it will have to make sure that: client_id is present the user is logged-in (redirect to login page otherwise) The page must do the following: Fetch an existing authorization for the client by the logged-in user from the API. Fetch the client from the API. Fetch all defined scopes with their descriptions from the API. Determine which scopes are requested: IF the scope query parameter is set, split it on whitespace &quot; &quot;. OR the fetched client's scope param. Compare the requested scopes to the already-authorized scopes (if any). IF there are yet-to-be-authorized scopes, show them to the user and ask for permission. Call the authorization endpoint with all query params in the request body plus &quot;permission_granted&quot;: &lt;boolean&gt; (this should be true if the user has already granted permission for all requested scopes). Process the response IF 200 OK and redirect_to , then redirect to the provided link. This redirect may also contain an error response. IF 400 Bad Request and errors , show the user an error message and don't redirect (this basically only happens if something is wrong with request parameters that would make it unsafe to redirect to the client, for example, the redirect_uri does not match the one configured for the client). React example A React example can be found here . Add API endpoints needed for authorization page You will need the following (or similar in GraphQL or something): GET /api/scopes (public) all defined application scopes, and probably their (default) descriptions, e.g. {&quot;profile:read&quot;: &quot;View your profile details like your name and email.&quot;} . GET /api/oauth2_clients/:id (public) Oauth2 client by ID. Be careful not to render the client secret here! GET /api/my/oauth2_authorizations/:client_id (private) current user's existing authorization for the specified client. Implementations for these endpoints are trivial and are not shown. Restrict third-party application access using scopes You are now basically done as far as adding CharonOauth2 to your app is concerned. Hurray! However, you actually still have to do the most difficult part :see_no_evil:, which is restricting third-party access to your API using scopes (technically, the part of it that functions as an Oauth2 resource server). For reasons explained below, this is something that cannot be abstracted away in a library. What are scopes? Scopes are not the easiest concept to grasp in the first place. They are best thought-of as permissions for applications, as opposed to permissions for users. For an operation to be authorized, both the application and the user must be authorized to perform it. For example, let's imagine your app can open a building's door. A user is authorized to open a door if they belong to the building (user permissions) However, you don't want just any third-party app to open a door on behalf of your user, except when the user has explicitly granted permission to that app (application permissions). That is why you want to restrict open-door capability to apps with scope door:open , for example. So in an Oauth2-enabled app, user permissions (roles etc) can't replace scopes, and scopes can't replace user permissions. It is not always straightforward which scopes to define for your app, nor is it always simple which scopes should be needed for which operations. Does door:open imply door:read , in other words, are scopes hierarchical? It's probably best if they are not, not in the last place to preserve your own sanity, and since your open-door endpoint may return the door it has just opened in its response body, the endpoint should then require both scopes. Another problem arises if your API returns other users' data. For example, if your application provides a GET /my/building/residents endpoint, you may run into privacy or even legal issues if you let third-party apps access that endpoint. Your users may have agreed somewhere that their co-residents can see their names, and that your application knows who live together in the same building. So without third-party access, everything is fine. However, if you then add Oauth2 third-party app access, a user grants permission to such an app to use their account, and that app can then see other user's names, a situation has arisen in which those other users have NOT granted any permissions to the third-party app, but it has some of their data anyway. So design your API and scopes well. Recommendations You should probably never allow third-party applications to do the following things, to prevent privilege escalation: Read, create or update oauth2 grants, authorizations or clients. Update a user's login credentials like passwords or MFA methods. Read, create or update a user's push tokens. Read, create or update a user's (non-Oauth2) sessions. Access highly privileged accounts like application-wide admin accounts, if you have those. Read other users' profiles. Refresh tokens using an existing Charon session controller. It is especially important to be aware of this if your use of CharonOauth2 creates a combined authorization- and resource server. You can simply use an existing session controller (for example, the one you created for Charon ) and grant all scopes to tokens handed out by it. Or add a &quot;special&quot; scope that only first-party clients that authenticate in this way can use. Alternatively, you can go full oauth2, don't add or throw away your Charon session controller, and add a special oauth2 client app that has access to scopes that other clients don't, and use that for your own applications. Enforcing scopes This is the easy part, simply verify the scope claim in a token: defmodule MyAppWeb.Router do use MyAppWeb , :router alias MyApp.CharonOauth2.Plugs . { AuthorizationEndpoint , TokenEndpoint } import Charon.TokenPlugs @my_charon_config MyApp.Charon . get_config ( ) ... pipeline :restrict_authorization_access do # conveniently, the scope claim is an ordset (see :ordsets) plug :verify_token_ordset_claim_contains , { &quot;scope&quot; , :ordsets . from_list ( ~w(authorization:write grant:write) ) } plug :verify_no_auth_error , &amp; MyAppWeb . charon_error_handler / 2 end scope &quot;/api&quot; do pipe_through [ :api , :valid_access_token , :restrict_authorization_access ] # auth endpoint MUST only be accessible by Charon-authenticated users # AND only by privileged, first-party applications # that have access to scopes authorization:write and grant:write (or similar) forward &quot;/oauth2/authorize&quot; , AuthorizationEndpoint , config : @my_charon_config end scope &quot;/api&quot; do # token endpoint does its own parsing and requires no authentication forward &quot;/oauth2/token&quot; , TokenEndpoint , config : @my_charon_config end end Managing authorizations and clients To round off, you may wish to add the ability for users to register their own Oauth2 clients (be the owner of a third-party app) or manage their authorizations. These require simple CRUD operations on MyApp.CharonOauth2.Clients and MyApp.CharonOauth2.Authorizations , respectively. Implementing controllers or GraphQL resolvers for those operations is entrusted to the reader's capabilities ;)","ref":"readme.html#how-to-use","title":"CharonOauth2 - How to use","type":"extras"},{"doc":"import React from &quot;react&quot;; import ApiService from &quot;@apiService&quot;; import { Oauth2Client } from &quot;@types&quot;; import { useAppContext } from &quot;@global/context&quot;; import { Button } from &quot;@components/atoms/Button/Component&quot;; export default function AuthorizeOauth2(): JSX.Element { let params = Object.fromEntries( new URLSearchParams(window.location.search).entries() ); const { setErrorMessage } = useAppContext(); const [scopeDescriptions, setScopeDescriptions] = React.useState&lt;{ [key: string]: string; }&gt;({}); const [authorizedScopes, setAuthorizedScopes] = React.useState&lt;string[]&gt;([]); const [newScopes, setNewScopes] = React.useState&lt;string[]&gt;([]); const [client, setClient] = React.useState&lt;Oauth2Client | null&gt;(null); React.useEffect((): void =&gt; { const clientId = params.client_id; const scopes = params.scope?.split(&quot; &quot;) ?? []; if (clientId) { fetchData(clientId, scopes).catch((error) =&gt; { setErrorMessage(&quot;Something went wrong&quot;); throw error; }); } }, [params]); const fetchData = async ( clientId: string, scopes: string[] ): Promise&lt;void&gt; =&gt; { const [ { data: { data: { oauth2_client: client }, }, }, { data: { data: { oauth2_authorizations: authorizations }, }, }, { data: { data: { token_scopes: scopeDescriptions }, }, }, ] = await Promise.all([ ApiService.oauth2Clients.show(clientId), ApiService.my.oauth2Authorizations.list({ client_id: clientId }), ApiService.tokenScopes.list(), ]); // If specific scopes are requested, we'll use those. Otherwise, default to all client scopes. const requestedScopes = scopes.length &gt; 0 ? scopes : client.scopes; const authorizedScopes = authorizations?.[0]?.scope ?? []; const newScopes = requestedScopes.filter( (s) =&gt; !authorizedScopes.includes(s) ); if (newScopes.length === 0) { // If all requested scopes are already authorized, we can just re-authorize on behalf of the user. await authorize(true); return; } setClient(client); setScopeDescriptions(scopeDescriptions); setAuthorizedScopes(authorizedScopes); setNewScopes(newScopes); }; const authorize = async (grantPermission: boolean): Promise&lt;void&gt; =&gt; { try { const { data: { redirect_to: redirectTo }, } = await ApiService.oauth2.authorize({ ...params, permission_granted: grantPermission, }); window.location.replace(redirectTo); } catch (error: any) { setErrorMessage(JSON.stringify(error.response.data)); } }; if (!client) { return &lt;div&gt;Loading...&lt;/div&gt;; } else { return ( &lt;div&gt; &lt;div&gt; &lt;div&gt; &lt;p&gt; The following app wishes to use your account on your behalf:{&quot; &quot;} &lt;strong&gt;{client.name}&lt;/strong&gt; - {client.description} &lt;/p&gt; &lt;br /&gt; {authorizedScopes.length &gt; 0 &amp;&amp; ( &lt;&gt; &lt;p&gt;You have already granted {client.name} permission to:&lt;/p&gt; &lt;ul&gt; {authorizedScopes.map((scope: string, i: number) =&gt; ( &lt;li key={i}&gt;{scopeDescriptions[scope] ?? scope}&lt;/li&gt; ))} &lt;/ul&gt; &lt;/&gt; )} &lt;p&gt;In addition, {client.name} wants to:&lt;/p&gt; &lt;ul&gt; {newScopes.map((scope: string, i: number) =&gt; ( &lt;li key={i}&gt;{scopeDescriptions[scope] ?? scope}&lt;/li&gt; ))} &lt;/ul&gt; &lt;/div&gt; &lt;/div&gt; &lt;Button as=&quot;button&quot; onClick={async () =&gt; await authorize(true)}&gt; Confirm &lt;/Button&gt; &lt;Button as=&quot;button&quot; onClick={async () =&gt; await authorize(false)}&gt; Deny &lt;/Button&gt; &lt;/div&gt; ); } }","ref":"example-auth-page.html","title":"Example authorization page (React)","type":"extras"}]